/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#ifndef _IPPOOL_RPC_H_RPCGEN
#define _IPPOOL_RPC_H_RPCGEN

#include <rpc/rpc.h>

#include <pthread.h>

#ifdef __cplusplus
extern "C" {
#endif

#define IPPOOL_APP_COPYRIGHT_INFO "(c) Copyright 2004-2008"
#define IPPOOL_APP_VENDOR_INFO "Katalix Systems Ltd."
#define IPPOOL_APP_MAJOR_VERSION 1
#define IPPOOL_APP_MINOR_VERSION 3

struct ippool_api_ip_addr {
	uint32_t s_addr;
};
typedef struct ippool_api_ip_addr ippool_api_ip_addr;

struct ippool_api_app_msg_data {
	char *build_date;
	char *build_time;
	int major;
	int minor;
	uint32_t cookie;
	struct {
		u_int patches_len;
		int *patches_val;
	} patches;
};
typedef struct ippool_api_app_msg_data ippool_api_app_msg_data;
#define IPPOOL_API_DEFAULT_MAX_ADDRS 0
#define IPPOOL_API_DEFAULT_NETMASK 0xffffff00

struct ippool_api_stats {
	u_long num_allocs;
	u_long num_frees;
	u_long num_alloc_fails;
};
typedef struct ippool_api_stats ippool_api_stats;

struct ippool_api_addrblock {
	struct ippool_api_ip_addr first_addr;
	int num_addrs;
	struct ippool_api_ip_addr netmask;
};
typedef struct ippool_api_addrblock ippool_api_addrblock;

struct ippool_api_addr_alloc_msg_data {
	int result_code;
	struct ippool_api_ip_addr addr;
};
typedef struct ippool_api_addr_alloc_msg_data ippool_api_addr_alloc_msg_data;
#define IPPOOL_API_FLAG_TRACE 1
#define IPPOOL_API_FLAG_DRAIN 2
#define IPPOOL_API_FLAG_MAX_ADDRS 4
#define IPPOOL_API_FLAG_NETMASK 8
#define IPPOOL_API_FLAG_ADDR_BLOCK 16

struct ippool_api_pool_msg_data {
	char *pool_name;
	int result_code;
	uint32_t flags;
	int trace;
	bool_t drain;
	int max_addrs;
	struct {
		u_int addr_block_len;
		struct ippool_api_addrblock *addr_block_val;
	} addr_block;
	int num_addrs;
	int num_avail;
	struct ippool_api_stats stats;
	struct {
		u_int avail_block_len;
		struct ippool_api_addrblock *avail_block_val;
	} avail_block;
	struct {
		u_int rsvd_block_len;
		struct ippool_api_addrblock *rsvd_block_val;
	} rsvd_block;
};
typedef struct ippool_api_pool_msg_data ippool_api_pool_msg_data;

struct ippool_api_pool_list_entry {
	char *pool_name;
	struct ippool_api_pool_list_entry *next;
};
typedef struct ippool_api_pool_list_entry ippool_api_pool_list_entry;

struct ippool_api_pool_list_msg_data {
	int result;
	int num_pools;
	struct ippool_api_pool_list_entry *pools;
};
typedef struct ippool_api_pool_list_msg_data ippool_api_pool_list_msg_data;

struct ippool_addrblock_add_1_argument {
	char *pool_name;
	struct ippool_api_addrblock addr;
};
typedef struct ippool_addrblock_add_1_argument ippool_addrblock_add_1_argument;

struct ippool_addrblock_remove_1_argument {
	char *pool_name;
	struct ippool_api_addrblock addr;
};
typedef struct ippool_addrblock_remove_1_argument ippool_addrblock_remove_1_argument;

struct ippool_addrblock_reserve_1_argument {
	char *pool_name;
	struct ippool_api_addrblock addr;
};
typedef struct ippool_addrblock_reserve_1_argument ippool_addrblock_reserve_1_argument;

struct ippool_addrblock_unreserve_1_argument {
	char *pool_name;
	struct ippool_api_addrblock addr;
};
typedef struct ippool_addrblock_unreserve_1_argument ippool_addrblock_unreserve_1_argument;

struct ippool_addr_free_1_argument {
	char *pool_name;
	struct ippool_api_ip_addr addr;
};
typedef struct ippool_addr_free_1_argument ippool_addr_free_1_argument;

#define IPPOOL_PROG 300775
#define IPPOOL_VERSION 1

#if defined(__STDC__) || defined(__cplusplus)
#define IPPOOL_APP_INFO_GET 1
extern  enum clnt_stat ippool_app_info_get_1(struct ippool_api_app_msg_data *, CLIENT *);
extern  bool_t ippool_app_info_get_1_svc(struct ippool_api_app_msg_data *, struct svc_req *);
#define IPPOOL_CREATE 2
extern  enum clnt_stat ippool_create_1(struct ippool_api_pool_msg_data , int *, CLIENT *);
extern  bool_t ippool_create_1_svc(struct ippool_api_pool_msg_data , int *, struct svc_req *);
#define IPPOOL_DELETE 3
extern  enum clnt_stat ippool_delete_1(char *, int *, CLIENT *);
extern  bool_t ippool_delete_1_svc(char *, int *, struct svc_req *);
#define IPPOOL_MODIFY 4
extern  enum clnt_stat ippool_modify_1(struct ippool_api_pool_msg_data , int *, CLIENT *);
extern  bool_t ippool_modify_1_svc(struct ippool_api_pool_msg_data , int *, struct svc_req *);
#define IPPOOL_GET 5
extern  enum clnt_stat ippool_get_1(char *, struct ippool_api_pool_msg_data *, CLIENT *);
extern  bool_t ippool_get_1_svc(char *, struct ippool_api_pool_msg_data *, struct svc_req *);
#define IPPOOL_LIST 6
extern  enum clnt_stat ippool_list_1(struct ippool_api_pool_list_msg_data *, CLIENT *);
extern  bool_t ippool_list_1_svc(struct ippool_api_pool_list_msg_data *, struct svc_req *);
#define IPPOOL_ADDRBLOCK_ADD 7
extern  enum clnt_stat ippool_addrblock_add_1(char *, struct ippool_api_addrblock , int *, CLIENT *);
extern  bool_t ippool_addrblock_add_1_svc(char *, struct ippool_api_addrblock , int *, struct svc_req *);
#define IPPOOL_ADDRBLOCK_REMOVE 8
extern  enum clnt_stat ippool_addrblock_remove_1(char *, struct ippool_api_addrblock , int *, CLIENT *);
extern  bool_t ippool_addrblock_remove_1_svc(char *, struct ippool_api_addrblock , int *, struct svc_req *);
#define IPPOOL_ADDRBLOCK_RESERVE 9
extern  enum clnt_stat ippool_addrblock_reserve_1(char *, struct ippool_api_addrblock , int *, CLIENT *);
extern  bool_t ippool_addrblock_reserve_1_svc(char *, struct ippool_api_addrblock , int *, struct svc_req *);
#define IPPOOL_ADDRBLOCK_UNRESERVE 10
extern  enum clnt_stat ippool_addrblock_unreserve_1(char *, struct ippool_api_addrblock , int *, CLIENT *);
extern  bool_t ippool_addrblock_unreserve_1_svc(char *, struct ippool_api_addrblock , int *, struct svc_req *);
#define IPPOOL_ADDR_ALLOC 11
extern  enum clnt_stat ippool_addr_alloc_1(char *, struct ippool_api_addr_alloc_msg_data *, CLIENT *);
extern  bool_t ippool_addr_alloc_1_svc(char *, struct ippool_api_addr_alloc_msg_data *, struct svc_req *);
#define IPPOOL_ADDR_FREE 12
extern  enum clnt_stat ippool_addr_free_1(char *, struct ippool_api_ip_addr , int *, CLIENT *);
extern  bool_t ippool_addr_free_1_svc(char *, struct ippool_api_ip_addr , int *, struct svc_req *);
#define IPPOOL_TEST_LOG 99
extern  enum clnt_stat ippool_test_log_1(char *, int *, CLIENT *);
extern  bool_t ippool_test_log_1_svc(char *, int *, struct svc_req *);
extern int ippool_prog_1_freeresult (SVCXPRT *, xdrproc_t, caddr_t);

#else /* K&R C */
#define IPPOOL_APP_INFO_GET 1
extern  enum clnt_stat ippool_app_info_get_1();
extern  bool_t ippool_app_info_get_1_svc();
#define IPPOOL_CREATE 2
extern  enum clnt_stat ippool_create_1();
extern  bool_t ippool_create_1_svc();
#define IPPOOL_DELETE 3
extern  enum clnt_stat ippool_delete_1();
extern  bool_t ippool_delete_1_svc();
#define IPPOOL_MODIFY 4
extern  enum clnt_stat ippool_modify_1();
extern  bool_t ippool_modify_1_svc();
#define IPPOOL_GET 5
extern  enum clnt_stat ippool_get_1();
extern  bool_t ippool_get_1_svc();
#define IPPOOL_LIST 6
extern  enum clnt_stat ippool_list_1();
extern  bool_t ippool_list_1_svc();
#define IPPOOL_ADDRBLOCK_ADD 7
extern  enum clnt_stat ippool_addrblock_add_1();
extern  bool_t ippool_addrblock_add_1_svc();
#define IPPOOL_ADDRBLOCK_REMOVE 8
extern  enum clnt_stat ippool_addrblock_remove_1();
extern  bool_t ippool_addrblock_remove_1_svc();
#define IPPOOL_ADDRBLOCK_RESERVE 9
extern  enum clnt_stat ippool_addrblock_reserve_1();
extern  bool_t ippool_addrblock_reserve_1_svc();
#define IPPOOL_ADDRBLOCK_UNRESERVE 10
extern  enum clnt_stat ippool_addrblock_unreserve_1();
extern  bool_t ippool_addrblock_unreserve_1_svc();
#define IPPOOL_ADDR_ALLOC 11
extern  enum clnt_stat ippool_addr_alloc_1();
extern  bool_t ippool_addr_alloc_1_svc();
#define IPPOOL_ADDR_FREE 12
extern  enum clnt_stat ippool_addr_free_1();
extern  bool_t ippool_addr_free_1_svc();
#define IPPOOL_TEST_LOG 99
extern  enum clnt_stat ippool_test_log_1();
extern  bool_t ippool_test_log_1_svc();
extern int ippool_prog_1_freeresult ();
#endif /* K&R C */

/* the xdr functions */

#if defined(__STDC__) || defined(__cplusplus)
extern  bool_t xdr_ippool_api_ip_addr (XDR *, ippool_api_ip_addr*);
extern  bool_t xdr_ippool_api_app_msg_data (XDR *, ippool_api_app_msg_data*);
extern  bool_t xdr_ippool_api_stats (XDR *, ippool_api_stats*);
extern  bool_t xdr_ippool_api_addrblock (XDR *, ippool_api_addrblock*);
extern  bool_t xdr_ippool_api_addr_alloc_msg_data (XDR *, ippool_api_addr_alloc_msg_data*);
extern  bool_t xdr_ippool_api_pool_msg_data (XDR *, ippool_api_pool_msg_data*);
extern  bool_t xdr_ippool_api_pool_list_entry (XDR *, ippool_api_pool_list_entry*);
extern  bool_t xdr_ippool_api_pool_list_msg_data (XDR *, ippool_api_pool_list_msg_data*);
extern  bool_t xdr_ippool_addrblock_add_1_argument (XDR *, ippool_addrblock_add_1_argument*);
extern  bool_t xdr_ippool_addrblock_remove_1_argument (XDR *, ippool_addrblock_remove_1_argument*);
extern  bool_t xdr_ippool_addrblock_reserve_1_argument (XDR *, ippool_addrblock_reserve_1_argument*);
extern  bool_t xdr_ippool_addrblock_unreserve_1_argument (XDR *, ippool_addrblock_unreserve_1_argument*);
extern  bool_t xdr_ippool_addr_free_1_argument (XDR *, ippool_addr_free_1_argument*);

#else /* K&R C */
extern bool_t xdr_ippool_api_ip_addr ();
extern bool_t xdr_ippool_api_app_msg_data ();
extern bool_t xdr_ippool_api_stats ();
extern bool_t xdr_ippool_api_addrblock ();
extern bool_t xdr_ippool_api_addr_alloc_msg_data ();
extern bool_t xdr_ippool_api_pool_msg_data ();
extern bool_t xdr_ippool_api_pool_list_entry ();
extern bool_t xdr_ippool_api_pool_list_msg_data ();
extern bool_t xdr_ippool_addrblock_add_1_argument ();
extern bool_t xdr_ippool_addrblock_remove_1_argument ();
extern bool_t xdr_ippool_addrblock_reserve_1_argument ();
extern bool_t xdr_ippool_addrblock_unreserve_1_argument ();
extern bool_t xdr_ippool_addr_free_1_argument ();

#endif /* K&R C */

#ifdef __cplusplus
}
#endif

#endif /* !_IPPOOL_RPC_H_RPCGEN */
